Name:           jflex
Version:        1.4.3
Release:        23
Epoch:          0
Summary:        A Lexical Analyzer Generator for Java
License:        GPL
Group:          Development/Java
#Vendor:         JPackage Project
#Distribution:   JPackage
Source0:        http://www.jflex.de/jflex-1.4.3.tar.gz
Source1:        jflex.script
#Source2:        jflex-1.4.1-generated-files.tar.bz2
Patch0:         jflex-build_xml.patch
Patch1:         jflex-junit-incompatibility.patch
URL:            http://www.jflex.de/
Requires:       java_cup
Requires:       jpackage-utils
BuildRequires:  ant
BuildRequires:  java_cup
BuildRequires:  java-rpmbuild
BuildRequires:  junit
BuildArch:      noarch

%description
JFlex is a lexical analyzer generator for Java written in Java. It is 
also a rewrite of the very useful tool JLex which was developed by 
Elliot Berk at Princeton University. As Vern Paxson states for his C/C++ 
tool flex: they do not share any code though.

Design goals The main design goals of JFlex are:

    * Full unicode support
    * Fast generated scanners
    * Fast scanner generation
    * Convenient specification syntax
    * Platform independence
    * JLex compatibility

%package javadoc
Group:          Development/Java
Summary:        Javadoc for %{name}

%description javadoc
Javadoc for %{name}.

%prep
%setup -q
%patch0 -p0 -b .sav
%patch1 -p1 -b .sav

# Remove bundled stuff
find -name *.jar -delete
rm -rf jflex-1.4.3/src/java_cup

%{__sed} -i 's/\r//' COPYRIGHT
%{__sed} -i 's|includes="JFlex/\*\*,java_cup/\*\*,skeleton|includes="JFlex/\*\*,skeleton|g' src/build.xml

%build

pushd src
# intial build using the autogenerated sym.java LexParse.java and LexScan.java
# these are created by the jflex ant task which needs to be built first
CLASSPATH=%{_javadir}/junit.jar:%{_javadir}/java_cup.jar \
%ant jar-bootstrap
# now that the JFlex.jar has been build we can use jflex ant tasks
# removing the generated files and rebuilding using the JFlex.jar
CLASSPATH=%{_javadir}/junit.jar:%{_javadir}/java_cup.jar:../lib/JFlex.jar \
%ant genclean libclean jar

javadoc -sourcepath . -d ../api JFlex
popd

%install
# jar
mkdir -p %{buildroot}%{_javadir}
install -m 644 lib/JFlex.jar %{buildroot}%{_javadir}/%{name}-%{version}.jar
(cd %{buildroot}%{_javadir} && for jar in *-%{version}*; do ln -s ${jar} `echo $jar| sed  "s|-%{version}||g"`; done)
# compatibility symlink
(cd %{buildroot}%{_javadir} && ln -s jflex.jar JFlex.jar)
# javadoc
mkdir -p 755 %{buildroot}%{_javadocdir}/%{name}-%{version}
cp -a api/* %{buildroot}%{_javadocdir}/%{name}-%{version}
(cd %{buildroot}%{_javadocdir} && ln -s %{name}-%{version} %{name})

mkdir -p %{buildroot}%{_bindir}
install -m 755 %{SOURCE1} %{buildroot}%{_bindir}/jflex

perl -pi -e 's/\r$//g' examples/standalone/sample.inp

%post javadoc
rm -f %{_javadocdir}/%{name}
ln -s %{name}-%{version} %{_javadocdir}/%{name}

%postun javadoc
if [ "$1" = "0" ]; then
    rm -f %{_javadocdir}/%{name}
fi

%files
%defattr(0644,root,root,0755)
%doc COPYRIGHT doc examples src/README src/changelog
%attr(0755,root,root) %{_bindir}/jflex
%{_javadir}/%{name}.jar
%{_javadir}/%{name}-%{version}.jar
%{_javadir}/JFlex.jar

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-%{version}
%ghost %{_javadocdir}/%{name}

%changelog

* Mon Jun 15 2015 Denis Silakov <denis.silakov@rosalab.ru> 0:1.4.3-23
- (712667d) Rebuild with Java8


